Index: src/LinearAlgebra/Line.cpp
===================================================================
--- src/LinearAlgebra/Line.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Line.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,373 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Line.cpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "LinearAlgebra/Line.hpp"
+
+#include <cmath>
+#include <iostream>
+
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/gslmatrix.hpp"
+#include "Helpers/Info.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
+#include "Exceptions/SkewException.hpp"
+#include "LinearAlgebra/Plane.hpp"
+
+using namespace std;
+
+Line::Line(const Vector &_origin, const Vector &_direction) :
+  direction(new Vector(_direction))
+{
+  direction->Normalize();
+  origin.reset(new Vector(_origin.partition(*direction).second));
+}
+
+Line::Line(const Line &src) :
+  origin(new Vector(*src.origin)),
+  direction(new Vector(*src.direction))
+{}
+
+Line::~Line()
+{}
+
+Line &Line::operator=(const Line& rhs){
+  if(this!=&rhs){
+    origin.reset(new Vector(*rhs.origin));
+    direction.reset(new Vector(*rhs.direction));
+  }
+  return *this;
+}
+
+
+double Line::distance(const Vector &point) const{
+  // get any vector from line to point
+  Vector helper = point - *origin;
+  // partition this vector along direction
+  // the residue points from the line to the point
+  return helper.partition(*direction).second.Norm();
+}
+
+Vector Line::getClosestPoint(const Vector &point) const{
+  // get any vector from line to point
+  Vector helper = point - *origin;
+  // partition this vector along direction
+  // add only the part along the direction
+  return *origin + helper.partition(*direction).first;
+}
+
+Vector Line::getDirection() const{
+  return *direction;
+}
+
+Vector Line::getOrigin() const{
+  return *origin;
+}
+
+vector<Vector> Line::getPointsOnLine() const{
+  vector<Vector> res;
+  res.reserve(2);
+  res.push_back(*origin);
+  res.push_back(*origin+*direction);
+  return res;
+}
+
+/** Calculates the intersection of the two lines that are both on the same plane.
+ * This is taken from Weisstein, Eric W. "Line-Line Intersection." From MathWorld--A Wolfram Web Resource. http://mathworld.wolfram.com/Line-LineIntersection.html
+ * \param *out output stream for debugging
+ * \param *Line1a first vector of first line
+ * \param *Line1b second vector of first line
+ * \param *Line2a first vector of second line
+ * \param *Line2b second vector of second line
+ * \return true - \a this will contain the intersection on return, false - lines are parallel
+ */
+Vector Line::getIntersection(const Line& otherLine) const{
+  Info FunctionInfo(__func__);
+
+  pointset line1Points = getPointsOnLine();
+
+  Vector Line1a = line1Points[0];
+  Vector Line1b = line1Points[1];
+
+  pointset line2Points = otherLine.getPointsOnLine();
+
+  Vector Line2a = line2Points[0];
+  Vector Line2b = line2Points[1];
+
+  Vector res;
+
+  auto_ptr<GSLMatrix> M = auto_ptr<GSLMatrix>(new GSLMatrix(4,4));
+
+  M->SetAll(1.);
+  for (int i=0;i<3;i++) {
+    M->Set(0, i, Line1a[i]);
+    M->Set(1, i, Line1b[i]);
+    M->Set(2, i, Line2a[i]);
+    M->Set(3, i, Line2b[i]);
+  }
+
+  //Log() << Verbose(1) << "Coefficent matrix is:" << endl;
+  //for (int i=0;i<4;i++) {
+  //  for (int j=0;j<4;j++)
+  //    cout << "\t" << M->Get(i,j);
+  //  cout << endl;
+  //}
+  if (fabs(M->Determinant()) > MYEPSILON) {
+    Log() << Verbose(1) << "Determinant of coefficient matrix is NOT zero." << endl;
+    throw SkewException(__FILE__,__LINE__);
+  }
+
+  Log() << Verbose(1) << "INFO: Line1a = " << Line1a << ", Line1b = " << Line1b << ", Line2a = " << Line2a << ", Line2b = " << Line2b << "." << endl;
+
+
+  // constuct a,b,c
+  Vector a = Line1b - Line1a;
+  Vector b = Line2b - Line2a;
+  Vector c = Line2a - Line1a;
+  Vector d = Line2b - Line1b;
+  Log() << Verbose(1) << "INFO: a = " << a << ", b = " << b << ", c = " << c << "." << endl;
+  if ((a.NormSquared() < MYEPSILON) || (b.NormSquared() < MYEPSILON)) {
+   res.Zero();
+   Log() << Verbose(1) << "At least one of the lines is ill-defined, i.e. offset equals second vector." << endl;
+   throw LinearDependenceException(__FILE__,__LINE__);
+  }
+
+  // check for parallelity
+  Vector parallel;
+  double factor = 0.;
+  if (fabs(a.ScalarProduct(b)*a.ScalarProduct(b)/a.NormSquared()/b.NormSquared() - 1.) < MYEPSILON) {
+    parallel = Line1a - Line2a;
+    factor = parallel.ScalarProduct(a)/a.Norm();
+    if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
+      res = Line2a;
+      Log() << Verbose(1) << "Lines conincide." << endl;
+      return res;
+    } else {
+      parallel = Line1a - Line2b;
+      factor = parallel.ScalarProduct(a)/a.Norm();
+      if ((factor >= -MYEPSILON) && (factor - 1. < MYEPSILON)) {
+        res = Line2b;
+        Log() << Verbose(1) << "Lines conincide." << endl;
+        return res;
+      }
+    }
+    Log() << Verbose(1) << "Lines are parallel." << endl;
+    res.Zero();
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+
+  // obtain s
+  double s;
+  Vector temp1, temp2;
+  temp1 = c;
+  temp1.VectorProduct(b);
+  temp2 = a;
+  temp2.VectorProduct(b);
+  Log() << Verbose(1) << "INFO: temp1 = " << temp1 << ", temp2 = " << temp2 << "." << endl;
+  if (fabs(temp2.NormSquared()) > MYEPSILON)
+    s = temp1.ScalarProduct(temp2)/temp2.NormSquared();
+  else
+    s = 0.;
+  Log() << Verbose(1) << "Factor s is " << temp1.ScalarProduct(temp2) << "/" << temp2.NormSquared() << " = " << s << "." << endl;
+
+  // construct intersection
+  res = a;
+  res.Scale(s);
+  res += Line1a;
+  Log() << Verbose(1) << "Intersection is at " << res << "." << endl;
+
+  return res;
+}
+
+/** Rotates the vector by an angle of \a alpha around this line.
+ * \param rhs Vector to rotate
+ * \param alpha rotation angle in radian
+ */
+Vector Line::rotateVector(const Vector &rhs, double alpha) const{
+  Vector helper = rhs;
+
+  // translate the coordinate system so that the line goes through (0,0,0)
+  helper -= *origin;
+
+  // partition the vector into a part that gets rotated and a part that lies along the line
+  pair<Vector,Vector> parts = helper.partition(*direction);
+
+  // we just keep anything that is along the axis
+  Vector res = parts.first;
+
+  // the rest has to be rotated
+  Vector a = parts.second;
+  // we only have to do the rest, if we actually could partition the vector
+  if(!a.IsZero()){
+    // construct a vector that is orthogonal to a and direction and has length |a|
+    Vector y = a;
+    // direction is normalized, so the result has length |a|
+    y.VectorProduct(*direction);
+
+    res += cos(alpha) * a + sin(alpha) * y;
+  }
+
+  // translate the coordinate system back
+  res += *origin;
+  return res;
+}
+
+Line Line::rotateLine(const Line &rhs, double alpha) const{
+  Vector lineOrigin = rotateVector(rhs.getOrigin(),alpha);
+  Vector helper = rhs.getDirection();
+  // rotate the direction without considering the ofset
+  pair<Vector,Vector> parts = helper.partition(*direction);
+  Vector lineDirection = parts.first;
+  Vector a = parts.second;
+  if(!a.IsZero()){
+    // construct a vector that is orthogonal to a and direction and has length |a|
+    Vector y = a;
+    // direction is normalized, so the result has length |a|
+    y.VectorProduct(*direction);
+
+    lineDirection += cos(alpha) * a + sin(alpha) * y;
+  }
+  return Line(lineOrigin,lineDirection);
+}
+
+Plane Line::rotatePlane(const Plane &rhs, double alpha) const{
+  vector<Vector> points = rhs.getPointsOnPlane();
+  transform(points.begin(),
+            points.end(),
+            points.begin(),
+            boost::bind(&Line::rotateVector,this,_1,alpha));
+  return Plane(points[0],points[1],points[2]);
+}
+
+Plane Line::getOrthogonalPlane(const Vector &origin) const{
+  return Plane(getDirection(),origin);
+}
+
+std::vector<Vector> Line::getSphereIntersections() const{
+  std::vector<Vector> res;
+
+  // line is kept in normalized form, so we can skip a lot of calculations
+  double discriminant = 1-origin->NormSquared();
+  // we might have 2, 1 or 0 solutions, depending on discriminant
+  if(discriminant>=0){
+    if(discriminant==0){
+      res.push_back(*origin);
+    }
+    else{
+      Vector helper = sqrt(discriminant)*(*direction);
+      res.push_back(*origin+helper);
+      res.push_back(*origin-helper);
+    }
+  }
+  return res;
+}
+
+LinePoint Line::getLinePoint(const Vector &point) const{
+  ASSERT(isContained(point),"Line point queried for point not on line");
+  Vector helper = point - (*origin);
+  double param = helper.ScalarProduct(*direction);
+  return LinePoint(*this,param);
+}
+
+LinePoint Line::posEndpoint() const{
+  return LinePoint(*this, numeric_limits<double>::infinity());
+}
+LinePoint Line::negEndpoint() const{
+  return LinePoint(*this,-numeric_limits<double>::infinity());
+}
+
+bool operator==(const Line &x,const Line &y){
+  return *x.origin == *y.origin && *x.direction == *y.direction;
+}
+
+Line makeLineThrough(const Vector &x1, const Vector &x2){
+  if(x1==x2){
+    throw LinearDependenceException(__FILE__,__LINE__);
+  }
+  return Line(x1,x1-x2);
+}
+
+/******************************** Points on the line ********************/
+
+LinePoint::LinePoint(const LinePoint &src) :
+  line(src.line),param(src.param)
+{}
+
+LinePoint::LinePoint(const Line &_line, double _param) :
+  line(_line),param(_param)
+{}
+
+LinePoint& LinePoint::operator=(const LinePoint &src){
+  line=src.line;
+  param=src.param;
+  return *this;
+}
+
+Vector LinePoint::getPoint() const{
+  ASSERT(!isInfinite(),"getPoint() on infinite LinePoint called");
+  return (*line.origin)+param*(*line.direction);
+}
+
+Line LinePoint::getLine() const{
+  return line;
+}
+
+bool LinePoint::isInfinite() const{
+  return isPosInfinity() || isNegInfinity();
+}
+bool LinePoint::isPosInfinity() const{
+  return param == numeric_limits<double>::infinity();
+}
+bool LinePoint::isNegInfinity() const{
+  return param ==-numeric_limits<double>::infinity();
+}
+
+bool operator==(const LinePoint &x, const LinePoint &y){
+  ASSERT(x.line==y.line,"Operation on two points of different lines");
+  return x.param == y.param;
+
+}
+bool operator<(const LinePoint &x, const LinePoint &y){
+  ASSERT(x.line==y.line,"Operation on two points of different lines");
+  return x.param<y.param;
+}
+
+ostream& operator<<(ostream& ost, const Line& m)
+{
+  const Vector origin = m.getOrigin();
+  const Vector direction = m.getDirection();
+  ost << "(";
+  for (int i=0;i<NDIM;i++) {
+    ost << origin[i];
+    if (i != 2)
+      ost << ",";
+  }
+  ost << ") -> (";
+  for (int i=0;i<NDIM;i++) {
+    ost << direction[i];
+    if (i != 2)
+      ost << ",";
+  }
+  ost << ")";
+  return ost;
+};
+
Index: src/LinearAlgebra/Line.hpp
===================================================================
--- src/LinearAlgebra/Line.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/Line.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,103 @@
+/*
+ * Line.hpp
+ *
+ *  Created on: Apr 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef LINE_HPP_
+#define LINE_HPP_
+
+#include "LinearAlgebra/Space.hpp"
+
+#include <iosfwd>
+#include <memory>
+#include <vector>
+
+class Vector;
+class Plane;
+class LinePoint;
+
+class Line : public Space
+{
+  friend bool operator==(const Line&,const Line&);
+  friend class LinePoint;
+public:
+  Line(const Vector &_origin, const Vector &_direction);
+  Line(const Line& _src);
+  virtual ~Line();
+
+  Line &operator=(const Line& rhs);
+
+  virtual double distance(const Vector &point) const;
+  virtual Vector getClosestPoint(const Vector &point) const;
+
+  Vector getDirection() const;
+  Vector getOrigin() const;
+
+  std::vector<Vector> getPointsOnLine() const;
+
+  Vector getIntersection(const Line& otherLine) const;
+
+  Vector rotateVector(const Vector &rhs, double alpha) const;
+  Line rotateLine(const Line &rhs, double alpha) const;
+  Plane rotatePlane(const Plane &rhs, double alpha) const;
+
+  Plane getOrthogonalPlane(const Vector &origin) const;
+
+  std::vector<Vector> getSphereIntersections() const;
+
+  LinePoint getLinePoint(const Vector&) const;
+  LinePoint posEndpoint() const;
+  LinePoint negEndpoint() const;
+
+
+
+private:
+  std::auto_ptr<Vector> origin;
+  std::auto_ptr<Vector> direction;
+};
+
+bool operator==(const Line&,const Line&);
+
+std::ostream & operator << (std::ostream& ost, const Line &m);
+
+/**
+ * Named constructor to make a line through two points
+ */
+Line makeLineThrough(const Vector &x1, const Vector &x2);
+
+/**
+ * Class for representing points on a line
+ * These objects allow comparison of points on the same line as well as specifying the
+ * infinite "endpoints" of a line.
+ */
+class LinePoint{
+  friend class Line;
+  friend bool operator==(const LinePoint&, const LinePoint&);
+  friend bool operator<(const LinePoint&, const LinePoint&);
+public:
+  LinePoint(const LinePoint&);
+  LinePoint& operator=(const LinePoint&);
+  Vector getPoint() const;
+  Line getLine() const;
+  bool isInfinite() const;
+  bool isPosInfinity() const;
+  bool isNegInfinity() const;
+
+private:
+  LinePoint(const Line&,double);
+  Line line;
+  double param;
+};
+
+bool operator==(const LinePoint&, const LinePoint&);
+bool operator<(const LinePoint&, const LinePoint&);
+
+inline bool operator!= (const LinePoint& x, const LinePoint& y) { return !(x==y); }
+inline bool operator>  (const LinePoint& x, const LinePoint& y) { return y<x; }
+inline bool operator<= (const LinePoint& x, const LinePoint& y) { return !(y<x); }
+inline bool operator>= (const LinePoint& x, const LinePoint& y) { return !(x<y); }
+
+
+#endif /* LINE_HPP_ */
Index: src/LinearAlgebra/LineSegment.cpp
===================================================================
--- src/LinearAlgebra/LineSegment.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/LineSegment.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,90 @@
+/*
+ * LineSegment.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#include "LinearAlgebra/LineSegment.hpp"
+#include "Helpers/Assert.hpp"
+
+#include "Line.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+using namespace std;
+
+LineSegment::LineSegment(const Vector &point1,const Vector &point2){
+  line.reset(new Line(point1,point1-point2));
+  begin.reset(new LinePoint(line->getLinePoint(point1)));
+  end.reset(new LinePoint(line->getLinePoint(point2)));
+}
+
+LineSegment::LineSegment(const LinePoint &lp1,const LinePoint &lp2){
+  ASSERT(lp1.getLine()==lp2.getLine(),"Cannot make a lineSegment with two different lines");
+  line.reset(new Line(lp1.getLine()));
+  begin.reset(new LinePoint(lp1));
+  end.reset(new LinePoint(lp2));
+}
+LineSegment::LineSegment(const LineSegment &src)
+{
+  line.reset(new Line(*src.line));
+  begin.reset(new LinePoint(*src.begin));
+  end.reset(new LinePoint(*src.end));
+}
+LineSegment::~LineSegment(){
+}
+LineSegment &LineSegment::operator=(const LineSegment &src){
+  if(this!=&src){
+    lineptr _line(new Line(*src.line));
+    pointptr _begin(new LinePoint(*src.begin));
+    pointptr _end(new LinePoint(*src.end));
+    line = _line;
+    begin = _begin;
+    end = _end;
+  }
+  return *this;
+}
+
+bool LineSegment::isContained(const Vector &point) const{
+  if(!line->isContained(point)){
+    return false;
+  }
+  LinePoint lp = line->getLinePoint(point);
+  return *begin <= lp && lp <= *end;
+}
+
+bool LineSegment::isContained(const LinePoint &lp) const{
+  ASSERT(lp.getLine()==*line,"Cannot compare Linepoints from different Lines");
+  return *begin <= lp && lp <= *end;
+}
+
+bool LineSegment::overlaps(const LineSegment &lineSeg) const{
+  ASSERT(*lineSeg.line == *line,"Cannot compare Linesegments from different Lines");
+  // mutual comparison of endpoints
+  return lineSeg.isContained(*end) || isContained(*lineSeg.end);
+}
+
+bool LineSegment::hasZeroLength() const{
+  return *begin==*end;
+}
+
+LinePoint LineSegment::getBegin() const{
+  return *begin;
+}
+
+LinePoint LineSegment::getEnd() const{
+  return *end;
+}
+
+Line LineSegment::getLine() const{
+  return *line;
+}
+
+bool operator==(const LineSegment &x,const LineSegment &y){
+  ASSERT(*x.line==*y.line,"Comparison of Linesegments from different lines");
+  return *x.begin == *y.begin && *x.end == *y.end;
+}
+bool operator<(const LineSegment &x,const LineSegment &y){
+  ASSERT(*x.line==*y.line,"Comparison of Linesegments from different lines");
+  return (*x.begin != *y.begin) ? *x.begin<*y.begin:*x.end<*y.end;
+}
Index: src/LinearAlgebra/LineSegment.hpp
===================================================================
--- src/LinearAlgebra/LineSegment.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/LineSegment.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,48 @@
+/*
+ * LineSegment.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef LINESEGMENT_HPP_
+#define LINESEGMENT_HPP_
+
+#include <memory>
+
+class Vector;
+class Line;
+class LinePoint;
+
+class LineSegment
+{
+  friend bool operator==(const LineSegment&,const LineSegment&);
+  friend bool operator<(const LineSegment&,const LineSegment&);
+
+  typedef std::auto_ptr<LinePoint> pointptr;
+  typedef std::auto_ptr<Line> lineptr;
+public:
+  LineSegment(const Vector&,const Vector&);
+  LineSegment(const LinePoint&,const LinePoint&);
+  LineSegment(const LineSegment&);
+  virtual ~LineSegment();
+  LineSegment &operator=(const LineSegment&);
+
+  bool isContained(const Vector &) const;
+  bool isContained(const LinePoint &) const;
+  bool overlaps(const LineSegment&) const;
+  bool hasZeroLength() const;
+  LinePoint getBegin() const;
+  LinePoint getEnd() const;
+  Line getLine() const;
+
+private:
+  pointptr begin;
+  pointptr end;
+  lineptr line;
+};
+
+bool operator==(const LineSegment&,const LineSegment&);
+bool operator<(const LineSegment&,const LineSegment&);
+
+#endif /* LINESEGMENT_HPP_ */
Index: src/LinearAlgebra/LineSegmentSet.cpp
===================================================================
--- src/LinearAlgebra/LineSegmentSet.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/LineSegmentSet.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,223 @@
+/*
+ * LineSegmentSet.cpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#include "LinearAlgebra/LineSegmentSet.hpp"
+
+#include "Helpers/Assert.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/LineSegment.hpp"
+
+#include "Helpers/Range.hpp"
+
+#include <algorithm>
+#include <boost/bind.hpp>
+
+using namespace std;
+
+LineSegmentSet::LineSegmentSet(const Line &_line) :
+  line(new Line(_line))
+{}
+
+LineSegmentSet::LineSegmentSet(const LineSegmentSet &src)
+{
+  line.reset(new Line(*src.line));
+  segments=src.segments;
+}
+
+LineSegmentSet& LineSegmentSet::operator=(const LineSegmentSet &src){
+  if(this!=&src){
+    lineptr _line(new Line(*src.line));
+    segments=src.segments;
+    line = _line;
+  }
+  return *this;
+}
+
+void LineSegmentSet::insert(const LineSegment &lineSeg){
+  ASSERT(*line==lineSeg.getLine(),"Inserted LineSegment was not from the line of the set");
+  // we might get messed up sets
+  if(lineSeg.hasZeroLength()){
+    // nothing to do here... there is practically nothing that is being inserted
+    return;
+  }
+  if(lineSeg.getBegin()>lineSeg.getEnd()){
+    // just insert the reversed set
+    insert(LineSegment(lineSeg.getEnd(),lineSeg.getBegin()));
+    return;
+  }
+  // get the first overlapping segment
+  set_t::iterator begin = find_if(segments.begin(),
+                                  segments.end(),
+                                  boost::bind(&LineSegment::overlaps,lineSeg,_1));
+  // see if we have overlapping segments
+  if(begin==segments.end()){
+    // no overlapping segments... we can just insert and get going
+    segments.insert(lineSeg);
+    return;
+  }
+  // get the last overlapping segment
+  set_t::iterator last = begin;
+  while(last!=segments.end() && lineSeg.overlaps(*last))++last;
+  last--;
+  // all segments between last and end now overlap and both are valid iterators
+  ASSERT(begin!=segments.end() && last!=segments.end(),"ERROR: last or begin are behind end of set");
+  // get the endpoints of the section
+  LinePoint beginPoint = min(begin->getBegin(),lineSeg.getBegin());
+  LinePoint endPoint = max(last->getEnd(),lineSeg.getEnd());
+  LineSegment insertSeg(beginPoint,endPoint);
+  // delete all overlapping segments
+  last++;
+  segments.erase(begin,last);
+  // insert the new combined segments
+  segments.insert(insertSeg);
+}
+
+void LineSegmentSet::erase(const LineSegment &lineSeg){
+  ASSERT(*line==lineSeg.getLine(),"Erased LineSegment was not from the line of the set");
+  // we might get messed up sets
+  if(lineSeg.hasZeroLength()){
+    // nothing to do here... there is practically nothing that is being erase
+    return;
+  }
+  if(lineSeg.getBegin()>lineSeg.getEnd()){
+    // just erase the reversed set
+    erase(LineSegment(lineSeg.getEnd(),lineSeg.getBegin()));
+    return;
+  }
+  // get the first overlapping segment
+  set_t::iterator begin = find_if(segments.begin(),
+                                  segments.end(),
+                                  boost::bind(&LineSegment::overlaps,lineSeg,_1));
+  if(begin==segments.end()){
+    // nothing to erase
+    return;
+  }
+  // get the last overlapping segment
+  set_t::iterator last = begin;
+  while(last!=segments.end() && lineSeg.overlaps(*last))++last;
+  last--;
+  // at the ends there might be two overlapping lineSegments of which parts remain
+  LineSegment beginSegment(begin->getBegin(),lineSeg.getBegin());
+  LineSegment endSegment(lineSeg.getEnd(),last->getEnd());
+  // erase all elements that have been overlapped
+  last++;
+  segments.erase(begin,last);
+  // insert the two segments if they still have space left
+  if(beginSegment.getBegin()<beginSegment.getEnd())
+    segments.insert(beginSegment);
+  if(endSegment.getBegin()<endSegment.getEnd())
+      segments.insert(endSegment);
+}
+
+LineSegmentSet::iterator LineSegmentSet::begin(){
+  return segments.begin();
+}
+LineSegmentSet::const_iterator LineSegmentSet::begin() const{
+  return segments.begin();
+}
+LineSegmentSet::iterator LineSegmentSet::end(){
+  return segments.end();
+}
+LineSegmentSet::const_iterator LineSegmentSet::end() const{
+  return segments.end();
+}
+
+bool LineSegmentSet::isContained(const Vector &point) const{
+  if(!line->isContained(point)){
+    return false;
+  }
+  LinePoint lp = line->getLinePoint(point);
+  for(set_t::iterator iter=segments.begin();iter!=segments.end();++iter){
+    if(iter->isContained(point)){
+      return true;
+    }
+    if(iter->getBegin()>lp){
+      break;
+    }
+  }
+  return false;
+}
+
+Line LineSegmentSet::getLine(){
+  return *line;
+}
+
+LineSegmentSet merge(const LineSegmentSet &x,const LineSegmentSet &y){
+  typedef range<LineSegmentSet::set_t::iterator> itRange;
+  ASSERT(*x.line==*y.line,"Lines of merges LineSegmentSets don't match");
+  LineSegmentSet res(*x.line);
+  // standard merge algorithm with a few modifications to deal with overlapping lines
+  itRange small(x.segments.begin(),x.segments.end());
+  itRange large(y.segments.begin(),y.segments.end());
+  while(small.first!=small.last && large.first != large.last){
+    if(large.first->getBegin()<small.first->getBegin()){
+      itRange tmp = small;
+      small = large;
+      large = tmp;
+    }
+
+    if(small.first->overlaps(*large.first)){
+      // get all overlapping segments from larger part
+      LineSegmentSet::set_t::iterator last = large.first;
+      while(last!=large.last && small.first->overlaps(*last))++last;
+      last--;
+      // get the endpoint of the new segment to be inserted
+      LinePoint lpEnd = max(small.first->getEnd(),last->getEnd());
+      res.segments.insert(LineSegment(small.first->getBegin(),lpEnd));
+      large.first=last; ++large.first; // all overlapping segments of the larger part have been dealt with
+    }
+    else{
+      // no overlap, we can just insert
+      res.segments.insert(*small.first);
+    }
+    ++small.first;
+  }
+  // deal with the rest of the iterator
+  // we don't know which one is done, so we just do both
+  res.segments.insert(small.first,small.last);
+  res.segments.insert(large.first,large.last);
+  return res;
+}
+
+LineSegmentSet intersect(const LineSegmentSet &x, const LineSegmentSet &y){
+  typedef range<LineSegmentSet::set_t::iterator> itRange;
+  ASSERT(*x.line==*y.line,"Lines of merges LineSegmentSets don't match");
+  LineSegmentSet res(*x.line);
+  itRange small(x.segments.begin(),x.segments.end());
+  itRange large(y.segments.begin(),y.segments.end());
+
+  while(small.first!=small.last && large.first != large.last){
+    if(large.first->getBegin()<small.first->getBegin()){
+      itRange tmp = small;
+      small = large;
+      large = tmp;
+    }
+    // add overlapping parts of segments from large
+    while(large.first!=large.last && small.first->overlaps(*large.first)){
+      LinePoint lpEnd = min(small.first->getEnd(),large.first->getEnd());
+      res.segments.insert(LineSegment(large.first->getBegin(),lpEnd));
+      ++large.first;
+    }
+    ++small.first;
+  }
+  return res;
+}
+
+LineSegmentSet invert(const LineSegmentSet &x){
+  LineSegmentSet res(*x.line);
+  LinePoint lpBegin = x.line->negEndpoint();
+  for(LineSegmentSet::set_t::iterator iter = x.segments.begin();iter!=x.segments.end();++iter){
+    if(lpBegin!=iter->getBegin())
+      res.segments.insert(LineSegment(lpBegin,iter->getBegin()));
+    // the end of the current scanned segment is the beginning of the next one to insert
+    lpBegin = iter->getEnd();
+  }
+  // we might need to extend to infinity
+  if(!lpBegin.isPosInfinity())
+    res.segments.insert(LineSegment(lpBegin,x.line->posEndpoint()));
+  return res;
+}
Index: src/LinearAlgebra/LineSegmentSet.hpp
===================================================================
--- src/LinearAlgebra/LineSegmentSet.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/LinearAlgebra/LineSegmentSet.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,52 @@
+/*
+ * LineSegmentSet.hpp
+ *
+ *  Created on: Jul 22, 2010
+ *      Author: crueger
+ */
+
+#ifndef LINESEGMENTSET_HPP_
+#define LINESEGMENTSET_HPP_
+
+#include <memory>
+#include <set>
+
+class Vector;
+class Line;
+class LineSegment;
+
+class LineSegmentSet {
+  friend LineSegmentSet merge(const LineSegmentSet&,const LineSegmentSet&);
+  friend LineSegmentSet intersect(const LineSegmentSet&, const LineSegmentSet&);
+  friend LineSegmentSet invert(const LineSegmentSet &);
+
+  typedef std::set<LineSegment> set_t;
+  typedef std::auto_ptr<Line> lineptr;
+public:
+  typedef set_t::iterator iterator;
+  typedef set_t::const_iterator const_iterator;
+
+  LineSegmentSet(const Line&);
+  LineSegmentSet(const LineSegmentSet&);
+  LineSegmentSet& operator=(const LineSegmentSet&);
+
+  void insert(const LineSegment&);
+  void erase(const LineSegment&);
+
+  iterator       begin();
+  const_iterator begin() const;
+  iterator       end();
+  const_iterator end()   const;
+
+  bool isContained(const Vector &) const;
+  Line getLine();
+private:
+  lineptr line;
+  set_t segments;
+};
+
+LineSegmentSet merge(const LineSegmentSet&,const LineSegmentSet&);
+LineSegmentSet intersect(const LineSegmentSet&, const LineSegmentSet&);
+LineSegmentSet invert(const LineSegmentSet &);
+
+#endif /* LINESEGMENTSET_HPP_ */
